"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const testing_1 = require("@nestjs/testing");
const oso_module_1 = require("../oso.module");
const oso_constants_1 = require("../oso.constants");
describe('OsoModule', () => {
    let testApp;
    beforeEach(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        const mod = yield testing_1.Test.createTestingModule({
            imports: [oso_module_1.OsoModule.forRoot()],
        }).compile();
        testApp = mod.createNestApplication();
    }));
    it('options should be applied', () => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        const options = {
            loadStr: '',
        };
        const optMod = yield testing_1.Test.createTestingModule({
            imports: [oso_module_1.OsoModule.forRoot(options)],
        }).compile();
        const opts = optMod.get(oso_constants_1.OSO_MODULE_OPTIONS);
        expect(opts).toBe(options);
    }));
    it('should return a dynamic module', () => {
        const dynamicMod = oso_module_1.OsoModule.forRoot();
        expect(dynamicMod.module).toBeInstanceOf(Function);
    });
});
