"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OsoService = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const oso_1 = require("oso");
const oso_metadata_storage_1 = require("./oso-metadata.storage");
const oso_constants_1 = require("./oso.constants");
const FastGlob = require("fast-glob");
let OsoService = exports.OsoService = class OsoService extends oso_1.Oso {
    constructor(options) {
        super(options.osoOptions);
        this.options = options;
    }
    onModuleInit() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const providers = oso_metadata_storage_1.OsoMetadataStorage.getClasses();
            providers.forEach(m => {
                this.registerClass(m);
            });
            if (this.options.loadFile) {
                yield this._loadFiles([this.options.loadFile]);
            }
            if (this.options.loadFiles) {
                yield this._loadFiles(this.options.loadFiles);
            }
            if (this.options.loadStr) {
                yield this.loadStr(this.options.loadStr);
            }
        });
    }
    _loadFiles(patterns) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const files = yield FastGlob(patterns);
            yield this.loadFiles(files);
        });
    }
};
exports.OsoService = OsoService = tslib_1.__decorate([
    (0, common_1.Injectable)(),
    tslib_1.__param(0, (0, common_1.Inject)(oso_constants_1.OSO_MODULE_OPTIONS)),
    tslib_1.__metadata("design:paramtypes", [Object])
], OsoService);
